#!/usr/bin/python
import ConfigParser
from re import sub
import os

DESKTOPCACHE = "/usr/share/applications/desktop.en_US.utf8.cache"
BLACKLIST = [] # List of sections to skip

config = ConfigParser.ConfigParser()
config.read( DESKTOPCACHE )

sections = config.sections()

teststr = ""
for section in config.sections():
    if section in BLACKLIST: continue

    try:
        binary = config.get( section, 'TryExec' )
    except ConfigParser.NoOptionError:
        binary = config.get( section, 'Exec' )
    except:
        continue

    try:
        name = sub('\W', '', config.get( section, 'Name' ))
        terminal = config.get( section, 'Terminal' )
        categories = config.get( section, 'Categories' ).split(';')

        if terminal == True: continue
    except ConfigParser.NoOptionError:
        continue

    binary = binary.split(' ')[0]

    teststr += """
class Test%s(TestCase):
    launcher = '%s'

    def test_minimal(self):
        self.assertTrue(True)
""" % (name, binary)

# Generate the testcase script. You need to redirect to a file named
# test_sanitychecks.py to run it with mago
print """# This file was generated by %s
from mago import TestCase
import unittest

%s

if __name__ == "__main__":
    unittest.main()
""" % (os.path.basename(__file__), teststr)
